-----------------------------------------------------------------------------
-- |
-- Module      :  Lentil.Types
-- Copyright   :  © 2015 Francesco Ariis
-- License     :  GPLv3 (see the LICENSE file)
--
-- Types descriptions
-----------------------------------------------------------------------------

module Lentil.Types where



data Issue = Issue { iFile   :: FilePath,
                     iRow    :: Row,
                     iDesc   :: Description,
                     iTags   :: [Tag] }
             deriving (Eq, Show)

data Tag   = Tag { tagString :: String }
             deriving (Show, Eq, Ord)

type Description = String
type Row = Int

-- output format
data Format = TagPop | Pretty | Csv
            deriving (Show, Eq, Enum, Bounded)


-- tag delimiters
openDel, closeDel :: Char
openDel  = '['
closeDel = ']'

